# DataHoard


### About
DataHoard has been create for the sole reason of taking care of automatic mysql database backups.
This supports mailing for logging what is happening to the databases, future plans include supporting different services for updating the status of the databases, such as `Discord`, `Telegram`, `Slack` and more.


### Features

- [x] Database Exporting
- [ ] Log all errors to a final log
- [x] Email the log through email
- [ ] Discord WebHook
- [ ] Telegram Hook
- [ ] Docker Support

### How to Use
1. Setup the configuration file which is [This file](./config.example.json) and rename it into `config.json` instead of `config.example.json`.
2. Run the server by using the `npm start` command, this will start to run the program.
3. This does not run as a service and should be activated by a `cron` task, or on windows a `scheduler` task, this is completely up to you how you setup.

Example Config File: 
```js
{
    "options": {
        "parallel_nodes": 2, // Run two database backups at a time
        "parallel_node_tasks": 5, // Run 5 dumps at a time ( basically how many databases at once )
        "separate_into_tables": false // Separate all of the different tables into separate files
    },

    "smtp": {
        "host": "",
        "port": "",
        "ssl":  true,
        "username": "",
        "password": "",
        "email_from": ""
    },

    "nodes": [
        {
            "name":  "Main Connection",
            "debug": 0,
            "log":   true,
            "mail": {
                "enabled": true,
                "email_to": "main@example.com",
                "email_cc": [
                    "first@example.com"
                ]
            },

            "hostname": "localhost",
            "username": "root",
            "password": "",
            "databases": {
                // These two(2) can also be defined as Array<string> for filtering.
                "blacklist": ["mysql", "database_statistics", "not_important"],
                "whitelist": null
            }
        }
    ]
}
```


<br>
<br>
<br>

<div>Icons made by <a href="https://www.flaticon.com/authors/smashicons" title="Smashicons">Smashicons</a> from <a href="https://www.flaticon.com/" title="Flaticon">www.flaticon.com</a></div>
