function formatDate(d : Date) : string {

    let day    = (String(d.getDate() + 1)).padStart(2, "0")
    let month  = (String(d.getMonth())).padStart(2, "0");
    let year   = (String(d.getFullYear()));

    let hour   = (String(d.getHours())).padStart(2, "0");
    let minute = (String(d.getMinutes())).padStart(2, "0");

    // Return the formatted datye
    return `${day}/${month}/${year} ${hour}:${minute}`;
}


class logMessage {

    ts: Date;
    origin: string;
    message: string;

    constructor( message: string, origin: string = "Unknown", ts?: Date ) {
        
        // Initialize the date as the current date
        if ( !ts ) ts = new Date();

        // Initialize the log message's data
        this.ts      = ts;
        this.origin  = origin;
        this.message = message;
    }

    /**
     * Get the log as a string
     * @returns A string representation fo the log message
     */
    toString() : string {
        // Get the formatted date
        let dateFormatted = formatDate(this.ts);

        // return the formatted message
        return `[${dateFormatted}][${this.origin}]: ${this.message}`;
    }

}

class Logger {

    // An array of logs to represent in an email
    logData : Array<logMessage>;

    constructor() {
        // Initialize an array of logs
        this.logData = [];
    }

    sendEmailLog() : void{

    }

}

export class SystemControl {
    // The main logger of the system
    log: Logger;

    constructor() {
        // Create an instance of the logger
        this.log = new Logger();
    }

    /**
     * Send out a panic message and end the process
     * @param message The panic message
     */
    async panic(message: string) : Promise<void> {
        // Send out the error message
        console.error(message);

        // End the process
        this.endProcess();
    }

    async endProcess(exitCode : number = 100): Promise<void> {
        

        // Exit the process
        process.exit(exitCode);
    }

}